using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record FilePath(string DirectoryName,
                       string ExtensionLowered,
                       string FileNameFirstSegment,
                       string FullName,
                       int? Id,
                       bool IsIntelligentIdFormat,
                       string Name,
                       string NameWithoutExtension,
                       int? SortOrder)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, FilePathSourceGenerationContext.Default.FilePath);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(FilePath))]
public partial class FilePathSourceGenerationContext : JsonSerializerContext
{
}